//  **** BEGIN LICENSE BLOCK ****
//  Copyright(c) 2005-2006 Adam Judson
//
//
//  PhotoMap
//  - display user contributed photos in a map
//
//  This program is free software; you can redistribute it and/or modify it under
//  the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
//  Place, Suite 330, Boston, MA 02111-1307 USA
//
//  **** END LICENSE BLOCK ****


// the wrapper for our Yahoo map implementation
// has lots of problems...
function PhotoMapYMap(type) {
   this.init(type);
}

PhotoMapYMap.prototype = {
   __proto__ : new PhotoMapBaseMap(),

   getIncludes : function(preferences) {
      return '<script type="text/javascript" src="http://api.maps.yahoo.com/ajaxymap?v=3.0&appid=' + 
             preferences.getYahooAppid() + 
             '"></script>\n';
   },

   getOnload : function(homeLat, homeLon, homeZoom) {
      var onloadText =  '    function onLoad() {\n' +
                        '      document.getElementById("mapContainer").controller = photoMapController;\n' +
                        '      \n' +
                        '      var photoMap = new YMap(document.getElementById("mapContainer"), YAHOO_MAP_REG);\n' +
                        '      photoMap.addTypeControl();\n' +
                        '      photoMap.addZoomLong();\n' +
                        '      photoMapController.initMap(photoMap);\n' +
                        '      photoMap.drawZoomAndCenter(YGeoPoint(10.0, -10.0), 10);\n' +
                        '    }\n';
      return onloadText;
   },

   getController : function() {
      var controllerText =    '    function PhotoMapController() {\n' +
                              '      \n' +
                              '      this.initMap = function(photoMap) {\n' +
                              '         this.map = photoMap;\n' +
                              '         this.markers = {};\n' +
                              '      };\n' +
                              '      \n' +
                              '      \n' +
                              '      this.centerAndZoom = function(lat, lon, zoom) {\n' +
                              '         this.map.drawZoomAndCenter(new YGeoPoint(lat, lon), zoom);\n' +
                              '         this.map.panToLatLon(new YGeoPoint(lat, lon));\n' +
                              '         this.map.setZoomLevel(zoom);\n' +
                              '      };\n' +
                              '      \n' +
                              '      \n' +
                              '      this.getLocation = function() {\n' +
                              '         var centre = this.map.getCenterLatLon();\n' +
                              '         return {lat : centre.Lat, lon : centre.Lon};\n' +
                              '      };\n' +
                              '      \n' +
                              '      \n' +
                              '      this.getBounds = function() {\n' +
                              '         var bounds = this.map.getBoundsLatLon();\n' +
                              '         return {minX : bounds.LonMin, minY : bounds.LatMin, ' +
                              '                 maxX : bounds.LonMax, maxY : bounds.LatMax};\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.getZoom = function() {\n' +
                              '         return this.map.getZoomLevel();\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.setHandler = function(handler) {\n' +
                              '         this.handler = handler;\n' +
                              '         YEvent.Capture(this.map, EventsList.endPan,     photoMapMoveEnd);\n' +
                              '         YEvent.Capture(this.map, EventsList.endAutoPan, photoMapMoveEnd);\n' +
                              '         YEvent.Capture(this.map, EventsList.changeZoom, photoMapMoveEnd);\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.moveEnd = function() {\n' +
                              '        this.handler.mapMoved(this.getLocation(), this.getBounds());\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.markerSelected = function(marker, imgObj) {\n' +
                              '        marker.openSmartWindow("<div style=\'white-space:nowrap;\' ><a href=\'\' onclick=\'window.open(\\"" + imgObj.url + "\\");return false;\'>You are here:<br><img width=\'75px\' height=\'75px\' src=\'" + imgObj.smallUrl + "\'/></a></div>");\n' + 
                              '        this.handler.markerSelected(imgObj.lat, imgObj.lon);' +
                              '      };\n' +
                              '      \n' +
                              '      this.infoWindowOpen = function(marker) {\n' +
                              '         alert("infoWindowOpen()");\n' +
                              '        // marker.pmOpen = true;\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.infoWindowClose = function(marker) {\n' +
                              '         alert("infoWindowClose()");\n' +
                              '        // if (marker && marker.pmOpen) {\n' +
                              '        //    delete marker.pmOpen;' +
                              '        // }\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.clearMarkers = function() {\n' +
                              '        this.map.removeMarkersAll();\n' +
                              '        this.markers = {};\n' +
                              '        // this.map.getInfoWindow().hide();\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.setMapTypeMap = function() {\n' +
                              '        this.map.setMapType(YAHOO_MAP_REG);\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.setMapTypeSatellite = function() {\n' +
                              '        this.map.setMapType(YAHOO_MAP_SAT);;\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.setMapTypeHybrid = function() {\n' +
                              '        this.map.setMapType(YAHOO_MAP_HYB);\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.getType = function() {\n' +
                              '        if (this.map.getCurrentMapType() == YAHOO_MAP_HYB) {\n' +
                              '           return "hybrid";\n' +
                              '        } else if (this.map.getCurrentMapType() == YAHOO_MAP_SAT) {\n' +
                              '           return "satellite";\n' +
                              '        } else {\n' +
                              '           return "map";\n' +
                              '        }\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.addMarker = function(imgObj) {\n' +
                              '        if (imgObj) {\n' +
                              '           if (!this.markers[imgObj.key()]) {\n' +
                              '              var point = new YGeoPoint(imgObj.lat, imgObj.lon);\n' +
                              '              var marker = new YMarker(point);\n' +
                              '              YEvent.Capture(marker, EventsList.MouseClick,  function() {photoMapController.markerSelected(marker, imgObj);});\n' +
                              '              this.map.addOverlay(marker);\n' +
                              '              this.markers[imgObj.key()] = marker;\n' +
                              '           }\n' +
                              '        }\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.removeMarker = function(imgObj) {\n' +
                              '        if (imgObj) {\n' +
                              '           var marker = this.markers[imgObj.key()];\n' +
                              '           if (marker) {\n' +
                              '              this.map.removeOverlay(marker);\n' +
                              '              //if (marker.pmOpen) {\n' +
                              '              //   this.map.getInfoWindow().hide();\n' +
                              '              //}\n' +
                              '              delete this.markers[imgObj.key()];\n' +
                              '           }\n' +
                              '        }\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.addCenterMarker = function() {\n' +
                              '        var loc = this.getLocation();\n' +
                              '        var point = new YGeoPoint(loc.lat, loc.lon);\n' +
                              '        var marker = new YMarker(point);\n' +
                              '        YEvent.Capture(marker, EventsList.MouseClick,  function() {marker.openSmartWindow("<div style=\'white-space:nowrap;\' >This is where the picture will be added.<br>Make sure you are at the right <br>zoom level.</div>");});\n' +
                              '        this.map.addOverlay(marker);\n' +
                              '      };\n' +
                              '      \n' +
                              '    }\n' +
                              '\n' +
                              'photoMapController = new PhotoMapController();\n' + 
                              '\n' +
                              'function photoMapMoveEnd() {\n' +
                              '   photoMapController.moveEnd();\n' +
                              '};\n';
      return controllerText;
   },

   ensureInit : function(mapFrame) {
      if (!this.mapController) {
         this.mapController = mapFrame.contentWindow.document.getElementById("mapContainer").wrappedJSObject.controller;
         this.mapController.setHandler(this);
      }
   },

   setLocation : function(lat, lon, zoom) {
      this.mapController.centerAndZoom(lat, lon, this.convertToMapZoom(zoom));
   },

   getLocation : function() {
      return this.mapController.getLocation();
   },

   getBounds : function() {
      return this.mapController.getBounds();
   },

   convertToMapZoom : function(pmZoom) {
      return pmZoom;
   },

   getZoom : function() {
      return this.mapController.getZoom();
   },

   addMarker : function(imgObj) {
      this.mapController.addMarker(imgObj);
   },

   removeMarker : function(imgObj) {
      this.mapController.removeMarker(imgObj);
   },

   clearMarkers : function() {
      this.mapController.clearMarkers();
   },

   addCenterMarker : function() {
      this.mapController.addCenterMarker();
   }
};
